/*
 File: test_components.h
 Date and Time: Fri Jan 30 18:55:27 2015 
*/
#ifndef __test_components_h__
#define __test_components_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "angled_string.h"
#include "bad_char_set.h"
#include "c_comments.h"
#include "c_literal.h"
#include "c_string.h"
#include "dbl_colon.h"
#include "eol.h"
#include "esc_seq.h"
#include "identifier.h"
#include "int_no.h"
#include "linker_id.h"
#include "unq_str.h"
#include "ws.h"
#include "o2_externs.h"
#include "o2_code_end.h"
  
// monolithic grammar: no thread
extern yacco2::State S1_Ctest_components;
namespace NS_test_components {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[8];
};
class Ctest_components: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rpass3_ = 569//start_of_rule_list + 0
    ,rhs1_Rpass3_ = 1
    ,rhs2_Rpass3_ = 2
   ,R_Relems_ = 570//start_of_rule_list + 2
    ,rhs1_Relems_ = 3
    ,rhs2_Relems_ = 4
   ,R_Rtoken_ = 571//start_of_rule_list + 4
    ,rhs1_Rtoken_ = 5
    ,rhs2_Rtoken_ = 6
    ,rhs3_Rtoken_ = 7
    ,rhs4_Rtoken_ = 8
    ,rhs5_Rtoken_ = 9
   ,R_Rtoken_grp1_ = 572//start_of_rule_list + 6
    ,rhs1_Rtoken_grp1_ = 10
    ,rhs2_Rtoken_grp1_ = 11
    ,rhs3_Rtoken_grp1_ = 12
    ,rhs4_Rtoken_grp1_ = 13
    ,rhs5_Rtoken_grp1_ = 14
    ,rhs6_Rtoken_grp1_ = 15
    ,rhs7_Rtoken_grp1_ = 16
    ,rhs8_Rtoken_grp1_ = 17
    ,rhs9_Rtoken_grp1_ = 18
    ,rhs10_Rtoken_grp1_ = 19
    ,rhs11_Rtoken_grp1_ = 20
    ,rhs12_Rtoken_grp1_ = 21
    ,rhs13_Rtoken_grp1_ = 22
    ,rhs14_Rtoken_grp1_ = 23
   ,R_Rtoken_grp2_ = 573//start_of_rule_list + 8
    ,rhs1_Rtoken_grp2_ = 24
    ,rhs2_Rtoken_grp2_ = 25
    ,rhs3_Rtoken_grp2_ = 26
    ,rhs4_Rtoken_grp2_ = 27
    ,rhs5_Rtoken_grp2_ = 28
    ,rhs6_Rtoken_grp2_ = 29
    ,rhs7_Rtoken_grp2_ = 30
    ,rhs8_Rtoken_grp2_ = 31
    ,rhs9_Rtoken_grp2_ = 32
    ,rhs10_Rtoken_grp2_ = 33
    ,rhs11_Rtoken_grp2_ = 34
    ,rhs12_Rtoken_grp2_ = 35
   ,R_Rtoken_grp3_ = 574//start_of_rule_list + 10
    ,rhs1_Rtoken_grp3_ = 36
    ,rhs2_Rtoken_grp3_ = 37
    ,rhs3_Rtoken_grp3_ = 38
    ,rhs4_Rtoken_grp3_ = 39
    ,rhs5_Rtoken_grp3_ = 40
    ,rhs6_Rtoken_grp3_ = 41
    ,rhs7_Rtoken_grp3_ = 42
    ,rhs8_Rtoken_grp3_ = 43
    ,rhs9_Rtoken_grp3_ = 44
    ,rhs10_Rtoken_grp3_ = 45
    ,rhs11_Rtoken_grp3_ = 46
    ,rhs12_Rtoken_grp3_ = 47
    ,rhs13_Rtoken_grp3_ = 48
    ,rhs14_Rtoken_grp3_ = 49
   ,R_Rtoken_grp4_ = 575//start_of_rule_list + 12
    ,rhs1_Rtoken_grp4_ = 50
    ,rhs2_Rtoken_grp4_ = 51
    ,rhs3_Rtoken_grp4_ = 52
    ,rhs4_Rtoken_grp4_ = 53
    ,rhs5_Rtoken_grp4_ = 54
    ,rhs6_Rtoken_grp4_ = 55
    ,rhs7_Rtoken_grp4_ = 56
    ,rhs8_Rtoken_grp4_ = 57
    ,rhs9_Rtoken_grp4_ = 58
    ,rhs10_Rtoken_grp4_ = 59
    ,rhs11_Rtoken_grp4_ = 60
    ,rhs12_Rtoken_grp4_ = 61
    ,rhs13_Rtoken_grp4_ = 62
    ,rhs14_Rtoken_grp4_ = 63
    ,rhs15_Rtoken_grp4_ = 64
   ,R_Rtoken_grp5_ = 576//start_of_rule_list + 14
    ,rhs1_Rtoken_grp5_ = 65
    ,rhs2_Rtoken_grp5_ = 66
    ,rhs3_Rtoken_grp5_ = 67
    ,rhs4_Rtoken_grp5_ = 68
  };
  //no of la sets = 2
  //no of states = 71
  Ctest_components();
  ~Ctest_components();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[69];
 };
struct Rpass3;
struct Relems;
struct Rtoken;
struct Rtoken_grp1;
struct Rtoken_grp2;
struct Rtoken_grp3;
struct Rtoken_grp4;
struct Rtoken_grp5;
struct Rpass3:public yacco2::CAbs_lr1_sym {
  Rpass3(yacco2::Parser* P);
  void op();
  public:
};

struct Relems:public yacco2::CAbs_lr1_sym {
  Relems(yacco2::Parser* P);
  public:
};

struct Rtoken:public yacco2::CAbs_lr1_sym {
  Rtoken(yacco2::Parser* P);
  public:
};

yacco2::THR _YACCO2_CALL_TYPE
AR_Rtoken_grp1(yacco2::Parser* Caller_pp);// rule's arbitrator
struct Rtoken_grp1:public yacco2::CAbs_lr1_sym {
  Rtoken_grp1(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr10();
  void sr11();
  void sr12();
  void sr13();
  void sr14();
};

struct Rtoken_grp2:public yacco2::CAbs_lr1_sym {
  Rtoken_grp2(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr10();
  void sr11();
  void sr12();
};

struct Rtoken_grp3:public yacco2::CAbs_lr1_sym {
  Rtoken_grp3(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr10();
  void sr11();
  void sr12();
  void sr13();
  void sr14();
};

struct Rtoken_grp4:public yacco2::CAbs_lr1_sym {
  Rtoken_grp4(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr10();
  void sr11();
  void sr12();
  void sr13();
  void sr14();
  void sr15();
};

struct Rtoken_grp5:public yacco2::CAbs_lr1_sym {
  Rtoken_grp5(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
};

} // end of namespace

#endif
